/********************************************************************
    file:       registry.h
	
    purpose:    exports
*********************************************************************/

#ifndef _REGISTRY_H
#define _REGISTRY_H

// if compiling with MSVC++ use its protection against multiple inclusion
#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER

#ifdef REGISTRY_EXPORTS
#define REGISTRY_API __declspec(dllexport)
#else
#define REGISTRY_API __declspec(dllimport)
#endif

#define UNICODE
//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
//
// includes
//
#include <windows.h>
#include <string>
#include <sstream>

using std::string;
using std::ostringstream;
using std::istringstream;

// don't forget to change this in the version resource as well
const char g_szAppName[] = "registry";
const char g_szAppVersion[] = "1.2";

//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
//
// exports
//
#ifdef __cplusplus
extern "C" {
#endif // __cplusplus

//
// from registry.cpp
//
	// Module Initialization
	REGISTRY_API int initModuleEx(HWND hLiteStep, HINSTANCE hInstance,
                                 IN LPCSTR szLSpath);

	HWND CreateMessageWindow(HINSTANCE hInstance, LPCSTR pszClass, LPCSTR pszWndName);

	// Module Cleanup
	REGISTRY_API void quitModule(IN HINSTANCE hInstance);
	long lRetVal;
	bool keyExist(HKEY hRootKey, const string &sRegKeyPath);
	string* queryAKey(HKEY hRootKey, const string &sRegKeyPath, const string &sRegSubKey);

	// Window message handling
	LRESULT CALLBACK WndProc(HWND hWnd, UINT uMessage, WPARAM wParam, LPARAM lParam);
#ifdef __cplusplus
}
#endif // __cplusplus


#endif // _REGISTRY_H